
#include "grtpp.h"
#ifndef _WIN32
#include <vector>
#endif

namespace bec {

class Clipboard {
  std::list<grt::ObjectRef> _contents;
  std::string _description;

  sigc::signal<void> _changed_signal;
public:
  Clipboard() {};
  virtual ~Clipboard() {};

  sigc::signal<void> signal_changed() { return _changed_signal; }
  void changed() { _changed_signal.emit(); }

  virtual void clear() { _contents.clear(); }

  virtual bool empty() { return _contents.empty(); }

  virtual void append_data(const grt::ObjectRef &data) { _contents.push_back(data); }
  virtual bool is_data() const { return _contents.empty(); }
  virtual std::list<grt::ObjectRef> get_data() { return _contents; }

  void set_content_description(const std::string description) { _description= description; }
  std::string get_content_description() { return _description; }

//  virtual void set_string(const std::string &str)= 0;
//  virtual std::string get_string()= 0;
};

};
