#ifndef _GRT_MESSAGE_LIST_H_
#define _GRT_MESSAGE_LIST_H_

#include "tree_model.h"


namespace bec {

  class GRTManager;

  class MYSQLGRTBACKEND_PUBLIC_FUNC MessageListBE : public ListModel
  {
  public:
    enum Column {
      Time,
      Message,
      Detail
    };

    MessageListBE(GRTManager *grtm);

    void clear();
    virtual bool get_field(const NodeId &node, int column, std::string &value);
    virtual void refresh() {}
    virtual IconId get_field_icon(const NodeId &node, int column, IconSize size);
    virtual int count();

    sigc::signal<void> signal_show() { return _list_show; }
    sigc::signal<void> signal_changed() { return _list_changed; }

    void handle_message(const grt::Message &msg);

  private:
    GRTManager *_grtm;
    struct MessageEntry {
      IconId icon;
      time_t timestamp;
      std::string message;
      std::string detail;
    };

    IconId _error_icon;
    IconId _warning_icon;
    IconId _info_icon;

    std::vector<MessageEntry> _entries;
    sigc::signal<void> _list_changed;
    sigc::signal<void> _list_show;

    bool _notified;
  };

};


#endif
