#ifndef _GRT_MODULES_LIST_H_
#define _GRT_MODULES_LIST_H_

#include <grtpp.h>
#include "tree_model.h"

namespace bec {

class MYSQLGRTBACKEND_PUBLIC_FUNC ModulesTreeBE : public TreeModel
{
public:
  enum ModulesTreeColumns {
    Name
  };
  
  ModulesTreeBE(grt::GRT *grt);

  virtual int count_children(const NodeId &parent);
  virtual NodeId get_child(const NodeId &parent, int index);

  virtual bool get_field(const NodeId &node, int column, std::string &value);
  virtual IconId get_field_icon(const NodeId &node, int column, IconSize size);

  virtual std::string get_field_description(const NodeId &node, int column);
  
  virtual grt::Type get_field_type(const NodeId &node, int column);

  virtual void refresh();
  
private:
  grt::GRT *_grt;
  int _module_count;
};

};

#endif /* _GRT_MODULES_LIST_H_ */
