#ifndef _MYX_GRT_REPORTER
#define _MYX_GRT_REPORTER

#include "grtpp.h"
#include "grt_backend_public_interface.h"

namespace bec {


class MYSQLGRTBACKEND_PUBLIC_FUNC Reporter
{
protected:
  grt::GRT *Reporter_grt;
  // need to be mutable to work in const methods
  mutable int _error_count;   
  mutable int _warning_count;
  mutable bool _tracking;

public:
  Reporter(grt::GRT *grt);

  grt::GRT *grt() { return Reporter_grt; }

  inline bool is_tracking() const;
  inline void start_tracking() const;

  void flush() const;

  void report_warning(const char *format, ...) const;
  void report_error(const char *format, ...) const;
  void report_info(const char *format, ...) const;

  void report_summary(const char *operation_name) const;

  inline int error_count() const;
  inline int warning_count() const;
};



class MYSQLGRTBACKEND_PUBLIC_FUNC SummaryCentry
{
  Reporter* _rep;
  std::string _operation;
public:
  SummaryCentry(Reporter& parent, const std::string& operation);
  ~SummaryCentry();

private:
  SummaryCentry(SummaryCentry&);
  SummaryCentry& operator =(SummaryCentry&);
};


};

#endif /* _MYX_GRT_REPORTER */
