#ifndef _GRT_VALUE_INSPECTOR_H_
#define _GRT_VALUE_INSPECTOR_H_


#include <grtpp.h>

#include "tree_model.h"

#define ValueInspectorBE_VERSION 2

namespace bec {


class MYSQLGRTBACKEND_PUBLIC_FUNC ValueInspectorBE : public TreeModel
{
public:
  enum ValueInspectorColumns {
    Name,  // or group name
    Value, // not valid for groups
    Description, // description
    IsReadonly, // determines if given object member is editable
    EditMethod // only for objects, defined with attr:editas in the struct xml
  };

  static ValueInspectorBE *create(grt::GRT *grt, 
                                  const grt::ValueRef &value,
                                  bool grouped,
                                  bool process_editas_flag);

  static ValueInspectorBE *create(grt::GRT *grt,
                                  const std::vector<grt::ObjectRef> &objects);


  virtual bool add_item(NodeId &new_node)= 0;
  virtual bool delete_item(const NodeId &node)= 0;

  //virtual MYX_GRT_VALUE_TYPE get_field_type(const NodeId &node, int column)= 0;

  virtual grt::ValueRef get_grt_value(const NodeId &node, int column);

  virtual bool set_convert_field(const NodeId &node, int column, const std::string &value);
  virtual bool set_field(const NodeId &node, int column, const std::string &value);
  virtual bool set_field(const NodeId &node, int column, double value);
  virtual bool set_field(const NodeId &node, int column, int value);

  virtual IconId get_field_icon(const NodeId &node, int column, IconSize size);

public: // Responder methods
  

protected:
  grt::GRT *_grt;

  ValueInspectorBE(grt::GRT *grt);

  virtual grt::Type get_canonical_type(const NodeId &node)= 0;
  
  virtual bool set_value(const NodeId &node, const grt::ValueRef &value)= 0;
};

};

#endif /* _GRT_VALUE_INSPECTOR_H_ */
