#ifndef _CHARSET_LIST_H_
#define _CHARSET_LIST_H_

#include <grtpp.h>
#include "grt/tree_model.h"


namespace bec {
  
  class CharsetList : public ListModel {
  public:
    CharsetList(grt::GRT *grt, const std::string &path);

    enum CharsetListColumns {
      Name
    };

    virtual int count_children(const NodeId &parent);

    virtual bool get_field(const NodeId &node, int column, std::string &value);

    virtual std::string get_field_description(const NodeId &node, int column);

    void picked_charset(const NodeId &node);

  protected:
    grt::GRT *_grt;
    
    std::list<int> _recently_used;

    std::string _charset_list_path;

  };
  
};


#endif /* _CHARSET_LIST_H_ */
