#ifndef _DB_OBJECT_FILTER_BE_H_
#define _DB_OBJECT_FILTER_BE_H_

#include "grt/grt_manager.h"

#include "grts/structs.db.h"
#include "grts/structs.db.mgmt.h"

#include "grtdb_backend_public_interface.h"

namespace bec {

  class GrtStringListModel;

  class MYSQLGRTDBBACKEND_PUBLIC_FUNC DBObjectFilterBE
  {
  public:
    DBObjectFilterBE(GRTManager *grtm);

    virtual void set_object_type_name(const std::string &type_name);
    virtual const std::string & get_full_type_name() const;
    bec::IconId icon_id(bec::IconSize icon_size);

    void filter_model(GrtStringListModel *filter_model) { _filter_model= filter_model; }
    GrtStringListModel * filter_model() { return _filter_model; }
    void add_stored_filter_set(const std::string &name);
    void remove_stored_filter_set(int index);
    void load_stored_filter_set(int index);
    int stored_filter_set_index(const std::string &name);
    void load_stored_filter_set_list(std::list<std::string> &names);

  protected:
    GRTManager *_grtm;
    std::string _grt_type_name;
    std::string _full_type_name;
    grt::DictRef _stored_filter_sets;
    std::string _stored_filter_sets_filepath;
    GrtStringListModel *_filter_model;
  };

};



#endif /* _DB_OBJECT_FILTER_BE_H_ */
