#ifndef _DB_OBJECT_MASTER_FILTER_BE_H_
#define _DB_OBJECT_MASTER_FILTER_BE_H_


#include "grt/grt_manager.h"

#include "grts/structs.db.h"
#include "grts/structs.db.mgmt.h"

#include "grtdb_backend_public_interface.h"


namespace bec {

  class DBObjectFilterBE;

  class MYSQLGRTDBBACKEND_PUBLIC_FUNC DBObjectMasterFilterBE
  {
  public:
    DBObjectMasterFilterBE(GRTManager *grtm);

    void add_filter(DBObjectFilterBE *filter);
    void remove_all_filters();

    void add_stored_filter_set(const std::string &name, std::list<std::string> &names);
    void remove_stored_filter_set(int index);
    void load_stored_filter_set(int index, std::list<int> &indexes);
    void load_stored_filter_set_list(std::list<std::string> &names);

  protected:
    GRTManager *_grtm;
    std::vector<DBObjectFilterBE *> _filters;
    grt::DictRef _stored_master_filter_sets;
    std::string _stored_master_filter_sets_filepath;
  };

};


#endif /* _DB_OBJECT_MASTER_FILTER_BE_H_ */
