#ifndef _EDITOR_ROUTINE_H_
#define _EDITOR_ROUTINE_H_

#include "grtdb/editor_dbobject.h"
#include "grt/tree_model.h"

#include "grts/structs.db.h"

namespace bec {

class MYSQLGRTDBBACKEND_PUBLIC_FUNC RoutineEditorBE : public DBObjectEditorBE
{
protected:
  db_RoutineRef _routine;
  bool _has_syntax_error;

public:
  RoutineEditorBE(GRTManager *grtm, const db_RoutineRef &routine, const db_mgmt_RdbmsRef &rdbms); 

  virtual db_DatabaseObjectRef get_dbobject() { return get_routine(); }
  virtual db_RoutineRef get_routine() { return _routine; }

  virtual std::string get_sql();
  virtual void set_sql(const std::string &sql);
  grt::ValueRef parse_sql(grt::GRT*, grt::StringRef sql);
  bool has_syntax_error() { return _has_syntax_error; }

protected:
  virtual std::string get_object_type();
};

} // namespace bec 

#endif /* _EDITOR_ROUTINE_H_ */
