#ifndef _EDITOR_TABLE_INSERTS_H_
#define _EDITOR_TABLE_INSERTS_H_

#include "grt/tree_model.h"

#include "grtdb_backend_public_interface.h"

#include "grts/structs.db.h"

#include <deque>


namespace bec
{
  class TableEditorBE;

  class MYSQLGRTDBBACKEND_PUBLIC_FUNC TableInsertsGridBE : public GridModel
  {
  public:
    TableInsertsGridBE(TableEditorBE *table);

    virtual int get_column_count();
    virtual std::string get_column_caption(int column);
    db_ColumnRef get_column(int column);
    virtual ColumnType get_column_type(int column);

    virtual int count();

    virtual bool get_field(const NodeId &node, int column, std::string &value);
    virtual bool set_convert_field(const NodeId &node, int column, const std::string &value);

    virtual void refresh();

    bool set_inserts_text(const std::string &text);
    std::string get_inserts_text();

    virtual bool delete_node(const NodeId &node);

    void enable_placeholder_row(bool flag);

  protected:
    TableEditorBE *_owner;
   
    db_SimpleDatatypeRef get_column_simpletype(int column);
    void add_new_row(int column, const std::string &value);
    void update_data_rows(const std::list<int> &mapping);

    std::list<db_ColumnRef> columns;
    std::deque<std::vector<std::string> > rows;
    
    bool _placeholder_row;
  };

} 

#endif
