#include "stdafx.h"


#include "editor_view.h"
/**
 * @file  editor_view.cpp
 * @brief 
 */

using namespace grt;
using namespace bec;


ViewEditorBE::ViewEditorBE(GRTManager *grtm, const db_ViewRef &view, const db_mgmt_RdbmsRef &rdbms)
  : DBObjectEditorBE(grtm, view, rdbms), _view(view), _has_syntax_error(true)
{
}

std::string ViewEditorBE::get_query()
{
  std::string ret = get_view()->sqlDefinition();
  if ( ret.empty() )
  {
    ret = "CREATE VIEW `";
    ret += get_schema_name() + "`.`" + get_name() + "` AS\n";
  }
  
  return ret;
}

void ViewEditorBE::set_query(const std::string &sql)
{
  set_sql_parser_task_cb(sigc::mem_fun(this, &ViewEditorBE::parse_sql));
  set_sql(sql, _view);
}

grt::ValueRef ViewEditorBE::parse_sql(grt::GRT*, grt::StringRef sql)
{
  int err_count= _sql_parser->parse_view(_view, sql.c_str());
  _has_syntax_error= 0 < err_count;
  return grt::IntegerRef(err_count);
}
