#include "stdafx.h"

#include "module_utils.h"


void begin_undo_group(grt::UndoManager *undo_man)
{
  if (undo_man)
    undo_man->begin_undo_group();
}


void end_undo_group(grt::UndoManager *undo_man, std::string desc)
{
  if (undo_man)
  {
    undo_man->end_undo_group();
    undo_man->set_action_description(desc);
  }
}


void do_transactable_member_set(grt::UndoManager *undo_man, grt::ObjectRef object, const char *member, grt::ValueRef value)
{
  if (undo_man)
    undo_man->add_undo(new grt::UndoObjectChangeAction(object, member, object.get_member(member)));
  object.set_member(member, value);
}


void do_transactable_list_insert(grt::UndoManager *undo_man, grt::BaseListRef list, grt::ValueRef val)
{
  if (undo_man)
    undo_man->add_undo(new grt::UndoListInsertAction(list));
  list.ginsert(val);
}


void do_transactable_list_remove(grt::UndoManager *undo_man, grt::BaseListRef list, grt::ValueRef val)
{
  if (undo_man)
    undo_man->add_undo(new grt::UndoListRemoveAction(list, val));
  list.gremove_value(val);
}


void do_transactable_list_remove(grt::UndoManager *undo_man, grt::BaseListRef list, size_t index)
{
  if (undo_man)
    undo_man->add_undo(new grt::UndoListRemoveAction(list, index));
  list.remove(index);
}
