#ifndef _MODULE_UTILS_
#define _MODULE_UTILS_


#include "sql_parser_public_interface.h"
#include <grtpp_undo_manager.h>


template<typename T1, typename T2>
void overwrite_default_option(T2 &value, const char *name, grt::DictRef &options)
{
  if (options.is_valid() && options.has_key(name))
    value= (T2)T1::cast_from(options.get(name));
}


template<typename T>
void overwrite_default_option(T &value, const char *name, grt::DictRef &options, bool init_with_empty_value)
{
  if (options.is_valid() && options.has_key(name))
  {
    value= T::cast_from(options.get(name));
    if (init_with_empty_value && !value.is_valid())
      value= T(options.get_grt());
  }
}


SQL_PARSER_PUBLIC_FUNC void begin_undo_group(grt::UndoManager *undo_man);
SQL_PARSER_PUBLIC_FUNC void end_undo_group(grt::UndoManager *undo_man, std::string desc);

SQL_PARSER_PUBLIC_FUNC void do_transactable_member_set(grt::UndoManager *undo_man, grt::ObjectRef object, const char *member, grt::ValueRef value);
SQL_PARSER_PUBLIC_FUNC void do_transactable_list_insert(grt::UndoManager *undo_man, grt::BaseListRef list, grt::ValueRef val);
SQL_PARSER_PUBLIC_FUNC void do_transactable_list_remove(grt::UndoManager *undo_man, grt::BaseListRef list, grt::ValueRef val);
SQL_PARSER_PUBLIC_FUNC void do_transactable_list_remove_by(grt::UndoManager *undo_man, grt::BaseListRef list, size_t index);


#endif // _MODULE_UTILS_
