#include "stdafx.h"

#include "sql_facade.h"


using namespace grt;


SqlFacade * SqlFacade::instance_for_db_obj(db_DatabaseObjectRef db_obj)
{
  db_mgmt_RdbmsRef rdbms;

  if (db_obj.is_instance(db_Table(db_obj.get_grt()).get_metaclass())
    || db_obj.is_instance(db_View(db_obj.get_grt()).get_metaclass())
    || db_obj.is_instance(db_Routine(db_obj.get_grt()).get_metaclass())
    || db_obj.is_instance(db_RoutineGroup(db_obj.get_grt()).get_metaclass()))
  {
    rdbms= db_mgmt_RdbmsRef::cast_from(db_obj->owner()->owner()->owner()->get_member("rdbms"));
  }

  return instance_for_rdbms(rdbms);
}


SqlFacade * SqlFacade::instance_for_rdbms(db_mgmt_RdbmsRef rdbms)
{
  return  instance_for_rdbms_name(rdbms->get_grt(), rdbms->name());
}


SqlFacade * SqlFacade::instance_for_rdbms_name(GRT *grt, const std::string &name)
{
  const char *def_module_name= "SqlFacade";
  std::string module_name= name + def_module_name;
  SqlFacade *module= dynamic_cast<SqlFacade*>(grt->get_module(module_name));
  if (!module)
		throw std::runtime_error(strfmt("Can't get '%s' module."));
  return module;
}
