#ifndef _SQL_PARSER_H_
#define _SQL_PARSER_H_


#include "sql_parser_public_interface.h"
#include "sql_parser_base.h"


/**
 * Defines interface to fill provided catalog with schemata/tables/views/routines/etc. parsed from the given DDL script.
 * Serves as a base class for all parsers transforming DDL script into GRT schema objects.
 * 
 * @ingroup sqlparser
 */
class SQL_PARSER_PUBLIC_FUNC Sql_parser : virtual public Sql_parser_base
{
public:
  virtual int parse_sql_script(db_CatalogRef catalog, const char *sql_script, grt::DictRef options)= 0;
  virtual int parse_sql_script_file(db_CatalogRef catalog, const char *sql_script_filename, grt::DictRef options)= 0;
};


#endif // _SQL_PARSER_H_
