#ifndef _CHECKBOX_LIST_CONTROL_H_
#define _CHECKBOX_LIST_CONTROL_H_

#include "mforms/mforms.h"
#include "grtpp.h"

class StringCheckBoxList : public mforms::ScrollPanel
{
  std::vector<mforms::CheckBox*> _items;
  mforms::Box _box;
  sigc::signal<void> _signal_changed;
  
  
  void toggled();
  
public:
  StringCheckBoxList();
  
  void set_strings(const std::vector<std::string> &strings);
  void set_strings(const grt::StringListRef &strings);
  virtual ~StringCheckBoxList();

  std::vector<std::string> get_selection();
  bool has_selection();
  
  void set_selected(const std::string &name, bool flag);
  
  sigc::signal<void> signal_changed() { return _signal_changed; }
};


#endif /* _CHECKBOX_LIST_CONTROL_H_ */
