#ifndef _GRT_WIZARD_PLUGIN_H_
#define _GRT_WIZARD_PLUGIN_H_

#include "grt_wizard_form.h"
#include "gui_plugin_base.h"

namespace grtui
{
  class GRTUI_EXPORT WizardPlugin : public GUIPluginBase, public WizardForm
  {
  public:
    WizardPlugin(bec::GRTManager *grtm, const grt::BaseListRef &args)
      : GUIPluginBase(grtm, args), WizardForm(grtm)
    {
    }

    virtual void execute()
    {
      // noop
    }

    virtual bec::GRTManager *grtm()
    {
      return GUIPluginBase::grtm();
    }

    virtual void show_plugin()
    {
      grt::DictRef values(grtm()->get_grt());

      run_modal(values);
    }
    
    virtual void hide_plugin()
    {
      close();
    }
  };
}


#endif /* _GRT_WIZARD_PLUGIN_H_ */
