#ifndef _GRTDB_OBJECT_FILTER_H_
#define _GRTDB_OBJECT_FILTER_H_

#include "mforms/mforms.h"
#include "grt/grt_manager.h"
#include "grtdb/db_object_filter.h"

namespace grtui
{
  
  class DBObjectFilterFrame : public mforms::Panel
  {
  public:
    DBObjectFilterFrame(bec::GRTManager *grtm);

    void set_object_class(const std::string &oclass, const std::string &caption_format);
    void set_models(bec::GrtStringListModel *model, bec::GrtStringListModel *excl_model);

  protected:
    bec::DBObjectFilterBE _filter_be;

    bec::GrtStringListModel *_model;
    bec::GrtStringListModel *_exclude_model;
    
    mforms::Box _box;

    mforms::Table _summary_table;

    mforms::ImageBox _icon;

    mforms::Label _summary_label1;
    mforms::Label _summary_bold_label1;
    mforms::Label _summary_label2;
    mforms::Label _summary_bold_label2;

    mforms::Label _toggle_label;
    mforms::Button _show_button;
    

    mforms::Table _detailed_table;

    mforms::Label _search_label;
    mforms::Label _filter_label;
    mforms::TextEntry _search_text;
    mforms::Selector _filter_combo;
    mforms::Button _add_button;
    mforms::Button _remove_button;

    mforms::Label _object_label;
    mforms::Label _mask_label;
    mforms::ListBox _object_list;
    mforms::ListBox _mask_list;
    
    mforms::Button _add1_button;
    mforms::Button _add2_button;
    mforms::Button _del1_button;
    mforms::Button _del2_button;
    mforms::Button _mask_button;
    
    mforms::Button _hide_button;

    void show_detailed();
    void hide_detailed();

    void update_button_enabled();
    
    void refresh();

    void add_mask();
    void add_clicked(bool all);
    void del_clicked(bool all);
  };
};

#endif /* _GRTDB_OBJECT_FILTER_H_ */
