#include "text_input_dialog.h"
#include "grt/common.h"

using namespace grtui;

TextInputDialog::TextInputDialog(mforms::Form *owner)
  : mforms::Form(owner), _button_box(true)
{  
  _table.set_padding(12);

  _table.set_row_count(3);
  _table.set_column_count(2);

  _table.add(&_description, 1, 2, 0, 1);
  _table.add(&_caption, 0, 1, 1, 2);
  _table.add(&_input, 1, 2, 1, 2);
  _table.set_row_spacing(8);
  _table.set_column_spacing(8);

  _table.add(&_button_box, 0, 2, 2, 3);
  
  _button_box.set_spacing(8);
  _cancel_button.set_text(_("Cancel"));
  _ok_button.set_text(_(" OK "));
  
  _button_box.add_end(&_cancel_button, false, false);
  _button_box.add_end(&_ok_button, false, false);

  set_content(&_table);
}


void TextInputDialog::set_description(const std::string &text)
{
  _description.set_text(text);
}


void TextInputDialog::set_caption(const std::string &text)
{
  _caption.set_text(text);
}


void TextInputDialog::set_value(const std::string &text)
{
  _input.set_value(text);
}


std::string TextInputDialog::get_value()
{
  return _input.get_string_value();
}


bool TextInputDialog::run()
{
  return run_modal(&_ok_button, &_cancel_button);
}
