
#include "wizard_object_filter_page.h"
/**
 * @file  wizard_object_filter_page.cpp
 * @brief 
 */

using namespace grtui;


WizardObjectFilterPage::WizardObjectFilterPage(WizardForm *form, const char *name)
  : WizardPage(form, name), _scroll_panel(false), _box(false), _filter_be(form->grtm())
{
  add(&_scroll_panel, true, true);
  _scroll_panel.add(&_box);
}



DBObjectFilterFrame *WizardObjectFilterPage::add_filter(const std::string &class_name,
                                       const std::string &caption_fmt,
                                       bec::GrtStringListModel *model,
                                       bec::GrtStringListModel *excl_model)
{
  DBObjectFilterFrame *filter;
    
  filter= new DBObjectFilterFrame(_form->grtm());
  filter->set_object_class(class_name, caption_fmt);
  filter->set_models(model, excl_model);
  _box.add(filter, false, true);
  _filters.push_back(filter);

  return filter;
}



void WizardObjectFilterPage::reset()
{
  for (std::vector<DBObjectFilterFrame*>::const_iterator iter= _filters.begin();
       iter != _filters.end(); ++iter)
  {
    _box.remove(*iter);
    delete *iter;
  }
  _filters.clear();
}

