#include "stdafx.h"

#include "recordset_be.h"
#include "recordset_data_storage_be.h"


using namespace bec;


Recordset::Recordset()
:
_data_storage(NULL)
{
}


Recordset::~Recordset()
{
}


void Recordset::commit(Recordset_data_storage *data_storage)
{
  if (data_storage)
    data_storage->serialize(this);
}


void Recordset::reset(Recordset_data_storage *data_storage)
{
  _field_names= std::vector<std::string>();
  _rs= std::vector<std::string>();

  if (data_storage)
    data_storage->unserialize(_field_names, _rs);
}


void Recordset::commit()
{
  commit(_data_storage);
}


void Recordset::reset()
{
  reset(_data_storage);
}


void Recordset::refresh()
{
}


int Recordset::count()
{
  int res= _field_names.size();
  if (0 < res)
    res= _rs.size() / res;
  return res;
}


bool Recordset::set_field(const NodeId &node, int column, const std::string &value)
{
  return false;
}


bool Recordset::set_field(const NodeId &node, int column, int value)
{
  return false;
}


bool Recordset::get_field_grt(const NodeId &node, int column, grt::ValueRef &value)
{
  if (!node.is_valid())
  {
    return false;
  }
  else if (node[0] < count())
  {
    value= grt::StringRef(_rs.at(node[0] * _field_names.size() + column));
    return true;
  }
  return false;
}


int Recordset::field_count()
{
  return _field_names.size();
}


std::string Recordset::field_name(int index)
{
  return _field_names.at(index);
}
