#ifndef _QUERY_RECORDSET_H_
#define _QUERY_RECORDSET_H_


#include "grtdb/grtdb_backend_public_interface.h"
//!#include "sqlide_public_interface.h"
#include "grt/tree_model.h"
#include <string>


class Recordset_data_storage;


class MYSQLGRTDBBACKEND_PUBLIC_FUNC /*//!SQLIDE_PUBLIC_FUNC*/ Recordset : public bec::ListModel
{
public:
  Recordset();
  virtual ~Recordset();

  Recordset_data_storage * data_storage() { return _data_storage; }
  void data_storage(Recordset_data_storage *data_storage) { _data_storage= data_storage; }

  void commit(Recordset_data_storage *data_storage);
  void reset(Recordset_data_storage *data_storage);
  void commit();
  void reset();

  void refresh();
  int count();

  bool set_field(const bec::NodeId &node, int column, const std::string &value);
  bool set_field(const bec::NodeId &node, int column, int value);

  int field_count();
  std::string field_name(int index);

private:
  Recordset_data_storage *_data_storage;
  std::vector<std::string> _rs;
  std::vector<std::string> _field_names;

protected:
  // for internal use only
  virtual bool get_field_grt(const bec::NodeId &node, int column, grt::ValueRef &value);
};

#pragma make_public(Recordset)


#endif /* _QUERY_RECORDSET_H_ */
