#ifndef _SQL_EDITOR_H_
#define _SQL_EDITOR_H_


#include <memory>
#include "grtdb/grtdb_backend_public_interface.h"
//!#include "sqlide_public_interface.h"
#include "grts/structs.db.mgmt.h"
#include "grt/grt_manager.h"
//!#include "interfaces/plugin.h"


#define Sql_VERSION "1.0"


class MYSQLGRTDBBACKEND_PUBLIC_FUNC /*//!SQLIDE_PUBLIC_FUNC*/ Sql_editor
{
public:
  static std::auto_ptr<Sql_editor> create_sql_editor(db_mgmt_RdbmsRef rdbms);

public:
  Sql_editor(db_mgmt_RdbmsRef rdbms);
  virtual ~Sql_editor();

  db_mgmt_RdbmsRef rdbms() { return _rdbms; }

  int int_option(std::string name);
  std::string string_option(std::string name);

protected:
  db_mgmt_RdbmsRef _rdbms;
  grt::DictRef _options;
};

#ifdef _WIN32
#pragma make_public(Sql_editor)
#endif

class MYSQLGRTDBBACKEND_PUBLIC_FUNC Sql
{
public:
  virtual std::auto_ptr<Sql_editor> getSqlEditor(db_mgmt_RdbmsRef rdbms)= 0;
  virtual ~Sql() {}
};


#endif /* _SQL_EDITOR_H_ */
