#include "stdafx.h"


#include "base_bridge.h"
#include "grt/grt_manager.h"

/**
 * @file  base_bridge.cpp
 * @brief 
 */


bool BridgeBase::is_main_thread()
{
  return bec::GRTManager::get_instance_for(get_object()->get_grt())->in_main_thread();
}


void BridgeBase::run_later(const sigc::slot<void> &slot)
{
  bec::GRTManager::get_instance_for(get_object()->get_grt())->run_when_idle(sigc::bind_return(slot,false));
}


void BridgeBase::run_later(grt::GRT *grt, const sigc::slot<void> &slot)
{
  bec::GRTManager::get_instance_for(grt)->run_when_idle(sigc::bind_return(slot,false));
}
