#ifndef _BASE_BRIDGE_H_
#define _BASE_BRIDGE_H_

#include <mdc.h>
#include <grtpp.h>

#include "wb_config.h"

#include "grts/structs.model.h"

#include "wb_canvas_bridge_public_interface.h"

#include "grt/grt_manager.h"


class MYSQLWBCANVASBRIDGE_PUBLIC BridgeBase : public sigc::trackable
{
protected:
  bec::GRTManager *get_grtm() { return bec::GRTManager::get_instance_for(get_object()->get_grt()); }
  
  void run_later(const sigc::slot<void> &slot);
  static void run_later(grt::GRT *grt, const sigc::slot<void> &slot);
  

  virtual GrtObject *get_object()= 0;

  bool is_main_thread();

public:
  virtual void unrealize()= 0;
};

#endif /* _BASE_BRIDGE_H_ */
