
#ifndef _LAYER_FIGURE_H_
#define _LAYER_FIGURE_H_


#include "mdc.h"

namespace wbfig {

class LayerAreaGroup : public mdc::AreaGroup
{
  mdc::Timestamp _last_click;
  mdc::Rect _initial_bounds;
  
  mdc::FontSpec _font;
  std::string _title;
  mdc::Color _title_fore;
  mdc::Color _title_back;

  cairo_text_extents_t _extents;
  bool _resizing;
  bool _extents_invalid;


  sigc::signal<void> _signal_activate;
  sigc::signal<void, mdc::Rect> _resize_signal;

  virtual bool on_drag_handle(mdc::ItemHandle *handle, const mdc::Point &pos, bool dragging);
  virtual bool on_button_press(mdc::CanvasItem *target, const mdc::Point &point, mdc::MouseButton button, mdc::EventState state);
  virtual bool on_button_release(mdc::CanvasItem *target, const mdc::Point &point, mdc::MouseButton button, mdc::EventState state);
  virtual bool on_click(mdc::CanvasItem *target, const mdc::Point &point, mdc::MouseButton button, mdc::EventState state);

  virtual void move_item(mdc::CanvasItem *item, const mdc::Point &pos);


  virtual void render(mdc::CairoCtx *cr);
  virtual void render_gl(mdc::CairoCtx *cr);

  mdc::Rect get_title_bounds() const;

public:
  LayerAreaGroup(mdc::Layer *layer);

  void set_title(const std::string &title);
  void set_font(const mdc::FontSpec &font);
  
  sigc::signal<void> signal_activate() { return _signal_activate; }
  sigc::signal<void, mdc::Rect> signal_interactive_resize() { return _resize_signal; }
};


};

#endif

