#ifndef _MODEL_LAYER_IMPL_H_
#define _MODEL_LAYER_IMPL_H_

#include <mdc.h>
#include <grtpp.h>

#include <grtpp_undo_manager.h>

#include "grts/structs.model.h"

#include "wb_canvas_bridge_public_interface.h"

#include "model_object_impl.h"

  
class MYSQLWBCANVASBRIDGE_PUBLIC model_Layer::ImplData : public model_Object::ImplData
{
  typedef model_Object::ImplData super;
  
  friend class ViewBase;
  
protected:
  mdc::AreaGroup *_area_group;

  mdc::CanvasView *get_canvas_view() const;

  void layer_bounds_changed(const mdc::Rect &rect);

  virtual bool is_realizable();

  void member_changed(const std::string &name, const grt::ValueRef &ovalue);

public:
  ImplData(model_Layer *owner);

  virtual ~ImplData();

  void raise_figure(const model_FigureRef &figure);
  void lower_figure(const model_FigureRef &figure);

public:  
  mdc::AreaGroup *get_area_group() const { return _area_group; }
  
  virtual void render_mini(mdc::CairoCtx *cr);
  virtual bool realize();
  virtual void unrealize();

private:
  model_Layer *self() const { return (model_Layer*)_self; }
};


#endif // _MODEL_LAYER_IMPL_H_
