#ifndef _MODEL_OBJECT_IMPL_H_
#define _MODEL_OBJECT_IMPL_H_

#include <mdc.h>
#include <grtpp.h>

#include "grts/structs.model.h"

#include "base_bridge.h"

#include "model_model_impl.h"


class MYSQLWBCANVASBRIDGE_PUBLIC model_Object::ImplData : public BridgeBase
{
protected:
  model_Object *_self;
  bool _in_view;


  ImplData(model_Object *object) : _self(object), _in_view(false) {}

  virtual GrtObject *get_object() { return _self; }

  void notify_realized();

public:
  virtual void set_in_view(bool flag);
  virtual bool in_view() { return _in_view; }

  virtual bool try_realize();

  virtual bool is_realizable()= 0;
  virtual bool realize()= 0;
  virtual void unrealize()= 0;
};

#endif /* _MODEL_OBJECT_IMPL_H_ */
