#include "stdafx.h"

#include "note_figure.h"

using namespace wbfig;

Note::Note(mdc::Layer *layer)
: BaseFigure(layer), _text(layer)
{
  set_allowed_resizing(false, false);
  set_accepts_focus(true);
  set_accepts_selection(true);
  set_auto_sizing(true);

  set_border_color(mdc::Color(0.5,0.5,0.5, 0.2));
  set_background_color(mdc::Color::White());
  set_draw_background(true);

  _text.set_padding(8, 8);
  _text.set_font(mdc::FontSpec("Helvetica", mdc::SNormal, mdc::WNormal, 11));
  _text.set_pen_color(mdc::Color::Black());
  _text.set_multi_line(true);

  add(&_text, false, false, true);
}


Note::~Note()
{
}


void Note::set_text(const std::string &text)
{
  _text.set_text(text);
  set_needs_relayout();
}


void Note::set_text_color(const mdc::Color &color)
{
  _text.set_pen_color(color);
}


void Note::set_content_font(const mdc::FontSpec &font)
{
  _text.set_font(font);
  set_needs_relayout();
}
