#ifndef __ROUTINE_GROUP_FIGURE_H__
#define __ROUTINE_GROUP_FIGURE_H__

#include "figure_common.h"
#include "wb_canvas_bridge_public_interface.h"

namespace wbbridge { namespace physical { class RoutinesFigure; }; };

namespace wbfig {

  class MYSQLWBCANVASBRIDGE_PUBLIC RoutineGroup : public BaseFigure
  {
    typedef BaseFigure super;

    friend class wbbridge::physical::RoutinesFigure;

    Titlebar _title;
    Titlebar _footer;
    mdc::Box _content_box;

    ItemList _routines;

  public:
    RoutineGroup(mdc::Layer *layer);
    virtual ~RoutineGroup();

    Titlebar *get_title() { return &_title; }
    
    virtual void set_title_font(const std::string &font);
    virtual void set_content_font(const mdc::FontSpec &font);

    virtual void set_color(const mdc::Color &color);
    void set_title(const std::string &title, const std::string &subtitle);

    virtual void toggle(bool flag);

    
    ItemList::iterator begin_routines_sync();
    ItemList::iterator sync_next_routine(ItemList::iterator iter,
                                                  const std::string &id,
                                                  const std::string &text);
    void end_routines_sync(ItemList::iterator iter);
  };
};

#endif

