#ifndef _WORKBENCH_PHYSICAL_CONNECTION_IMPL_H_
#define _WORKBENCH_PHYSICAL_CONNECTION_IMPL_H_

#include "model_connection_impl.h"
#include "grts/structs.workbench.physical.h"


namespace wbfig
{
  class FigureItem;
};

  
class MYSQLWBCANVASBRIDGE_PUBLIC workbench_physical_Connection::ImplData : public model_Connection::ImplData
{
  typedef model_Connection::ImplData super;
  
protected:
  sigc::connection _realize_conn;
  
  sigc::connection _table_changed_conn;

  bool _highlighting;


  void member_changed(const std::string &name, const grt::ValueRef &ovalue);
  
  virtual bool realize();
  virtual void unrealize();
  
  void update_line_ends();
  void layout_changed();
  void line_crossed(bool enter);
  void table_changed(const std::string &detail);
  
  virtual mdc::CanvasItem *get_start_canvas_item();
  virtual mdc::CanvasItem *get_end_canvas_item();

  virtual void caption_bounds_changed(const mdc::Rect &obounds, mdc::TextFigure *figure);

  void table_item_added(wbfig::FigureItem *item);
  void fk_member_changed(const std::string &member, const grt::ValueRef &ovalue);

  void object_realized(const model_ObjectRef &object);

  void update_connected_tables();

public:
  ImplData(workbench_physical_Connection *self);
  virtual ~ImplData();

  virtual void set_in_view(bool flag);

  void set_foreign_key(const db_ForeignKeyRef &fk);

private:
  workbench_physical_Connection *self() const { return (workbench_physical_Connection*)_self; }
};


#endif
