#ifndef _WORKBENCH_PHYSICAL_VIEW_IMPL_H_
#define _WORKBENCH_PHYSICAL_VIEW_IMPL_H_

#include "model_diagram_impl.h"
#include "grts/structs.workbench.physical.h"


class TableFigure;

class MYSQLWBCANVASBRIDGE_PUBLIC workbench_physical_Diagram::ImplData : public model_Diagram::ImplData
{
protected:
  typedef model_Diagram::ImplData super;
  sigc::slot<void, workbench_physical_TableFigure*> _enter_slot;
  sigc::slot<void, workbench_physical_TableFigure*> _leave_slot;

  void enter_table_callback(workbench_physical_TableFigure* table);
  void leave_table_callback(workbench_physical_TableFigure* table);

  std::map<std::string, model_FigureRef> _dbobject_to_figure;
  std::map<std::string, workbench_physical_ConnectionRef> _fk_to_connection;

  virtual void member_list_changed(grt::internal::OwnedList *alist, bool added, const grt::ValueRef &value);
  
public:
  ImplData(workbench_physical_Diagram *owner);

  void notify_table_realized(workbench_physical_TableFigure *table);

  void set_table_enter_slot(const sigc::slot<void, workbench_physical_TableFigure*> &slot);
  void set_table_leave_slot(const sigc::slot<void, workbench_physical_TableFigure*> &slot);

  workbench_physical_LayerRef place_new_layer(double x, double y, double width, double height, const std::string &name);

  workbench_physical_TableFigureRef place_table(const db_TableRef &table, double x, double y);
  workbench_physical_RoutineGroupFigureRef place_routine_group(const db_RoutineGroupRef &rgroup, double x, double y);
  workbench_physical_ViewFigureRef place_view(const db_ViewRef &view, double x, double y);

  workbench_physical_ConnectionRef create_connection_for_foreign_key(const db_ForeignKeyRef &fk);
  int create_connections_for_table(const db_TableRef &table);
  void delete_connections_for_table(const db_TableRef &table);


  model_FigureRef get_figure_for_dbobject(const db_DatabaseObjectRef &figure);

  void add_mapping(const db_DatabaseObjectRef &object, const model_FigureRef &figure);
  void remove_mapping(const db_DatabaseObjectRef &object);

  workbench_physical_ConnectionRef get_connection_for_foreign_key(const db_ForeignKeyRef &fk);

  void add_fk_mapping(const db_ForeignKeyRef &fk, const workbench_physical_ConnectionRef &connection);
  void remove_fk_mapping(const db_ForeignKeyRef &fk, const workbench_physical_ConnectionRef &connection= workbench_physical_ConnectionRef());

  
  void auto_place_db_objects(const grt::ListRef<db_DatabaseObject> &objects);
  
private:
  workbench_physical_Diagram *self() const { return (workbench_physical_Diagram*)_self; }
};

#endif
