#ifndef _WORKBENCH_PHYSICAL_ROUTINEGROUPFIGURE_IMPL_H_
#define _WORKBENCH_PHYSICAL_ROUTINEGROUPFIGURE_IMPL_H_

#include "model_figure_impl.h"
#include "grts/structs.workbench.physical.h"

#include "figure_common.h"
#include "routine_group_figure.h"


/** Routine Group figure implementation.
 * Implements inner working of routine group figures.
 * 
 * Figure contents are updated when the following changes:
 * 
 * <li>figure attributes (color, state etc)
 * <li>group name
 * <li>routine list (added, removed)
 * <li>routine name changes
 *
 * @ingroup Figures
 */
class MYSQLWBCANVASBRIDGE_PUBLIC workbench_physical_RoutineGroupFigure::ImplData : public model_Figure::ImplData
{
  typedef model_Figure::ImplData super;

protected:
  wbfig::RoutineGroup *_figure;
  
  virtual bool realize();

  void sync_routines();

  void contents_changed();

  void member_changed(const std::string &member, const grt::ValueRef &ovalue);
  void routinegroup_member_changed(const std::string &member, const grt::ValueRef &ovalue);

  virtual void set_in_view(bool flag);

public:
  ImplData(workbench_physical_RoutineGroupFigure *self);

  void set_routine_group(const db_RoutineGroupRef &rgroup);
  
  virtual wbfig::BaseFigure* get_canvas_item() const { return _figure; }
  virtual bool is_realizable();
  
  virtual void unrealize();
  
private:
  workbench_physical_RoutineGroupFigure *self() { return (workbench_physical_RoutineGroupFigure*)_self; }
};


#endif
