#ifndef _WORKBENCH_PHYSICAL_VIEWFIGURE_IMPL_H_
#define _WORKBENCH_PHYSICAL_VIEWFIGURE_IMPL_H_

#include "model_figure_impl.h"
#include "grts/structs.workbench.physical.h"

#include "view_figure.h"

/** View figure implementation.
 * Implements inner working of db view figures.
 * 
 * Figure contents are updated when the following changes:
 * 
 * <li>figure attributes (color, state etc)
 * <li>view name
 *
 * @ingroup Figures
 */
class MYSQLWBCANVASBRIDGE_PUBLIC workbench_physical_ViewFigure::ImplData : public model_Figure::ImplData
{
  typedef model_Figure::ImplData super;

protected:
  wbfig::View *_figure;
  
  sigc::connection _figure_conn;

  virtual bool realize();

  void view_member_changed(const std::string &name, const grt::ValueRef &ovalue);
  void member_changed(const std::string &name, const grt::ValueRef &ovalue);

  virtual void set_in_view(bool flag);

public:
  ImplData(workbench_physical_ViewFigure *owner);

  virtual wbfig::BaseFigure* get_canvas_item() const { return _figure; }
  virtual bool is_realizable();

  virtual void unrealize();

  void set_view(const db_ViewRef &view);
  
private:
  workbench_physical_ViewFigure *self() { return (workbench_physical_ViewFigure*)_self; }
};


#endif
