#ifndef _WB_HISTORY_TREE_H_
#define _WB_HISTORY_TREE_H_

#include "grt/tree_model.h"

namespace wb {
  class WBContext;

  class HistoryTreeBE : public bec::TreeModel
  {
    grt::UndoManager *_undom;
    WBContext *_wb;

    virtual int count_children(const bec::NodeId &parent);
    virtual bec::NodeId get_child(const bec::NodeId &parent, int index);
    virtual bool get_field(const bec::NodeId &node, int column, std::string &value);

    grt::ValueRef activate_node_grt(grt::GRT *grt, const bec::NodeId &node);

  public:
    enum Column 
    {
      Description,
      Type
    };

    HistoryTreeBE(WBContext *wb, grt::UndoManager *undom);

    virtual void refresh();

    virtual bool activate_node(const bec::NodeId &node);
  };
};


#endif
