#ifndef _DOCUMENT_PROPERTIES_FORM_H_
#define _DOCUMENT_PROPERTIES_FORM_H_


#include <mforms/mforms.h>

#include "workbench/wb_context_ui.h"

class DocumentPropertiesForm : public mforms::Form {
  
  mforms::Box _top_box;
  mforms::Box _bottom_box;

  std::list<mforms::View*> _widgets;

  mforms::TextEntry _entry1;
  mforms::TextEntry _entry2;
  mforms::TextEntry _entry3;
  mforms::TextEntry _entry4;
  mforms::TextEntry _entry5;
  mforms::TextEntry _entry6;
  mforms::TextBox _text;
  
  mforms::SizeGroup _btn_size_group;
  mforms::Button _ok_button;
  mforms::Button _cancel_button;
  
  wb::WBContextUI *_wbui;
  
  sigc::slot<void> _handle_close;

  void add_control(const std::string &caption, mforms::View *control);
  
  void ok_clicked();
  void cancel_clicked();
  
  void pull_values();
  void push_values();
  
public:
  DocumentPropertiesForm(wb::WBContextUI *wbui);
  virtual ~DocumentPropertiesForm();
  
  void set_closed_handler(const sigc::slot<void> &slot);
};


#endif /* _DOCUMENT_PROPERTIES_FORM_H_ */
