#ifndef _TOOLBAR_MANAGER_H_
#define _TOOLBAR_MANAGER_H_

#include <string>

namespace Gtk
{
  class Toolbar;
  class ToolButton;
}

namespace wb
{
  class CommandUI;
  class WBToolbarItem;
}

class MGGladeXML;

//==============================================================================
//
//==============================================================================
class ToolbarManager
{
  public:
    ToolbarManager(wb::CommandUI *be, MGGladeXML *ui);

    void rebuild_toolbar(const std::string& toolbar_name);
  private:
    void add_toolbar_item(Gtk::Box* toolbar, const wb::WBToolbarItem& item, bool right);
    void clicked(const Gtk::Button *btn);
    void toggled(const Gtk::ToggleButton *btn, const std::string &name, const std::string &option);
    void combo_changed(const std::string &toolbar, Gtk::ComboBoxText *combo);
    void color_combo_changed(const std::string &toolbar, Gtk::ComboBox *combo);
  
    wb::CommandUI       *_be;
    MGGladeXML          *_ui_wrp;
};

#endif /* _TOOLBAR_MANAGER_H_ */
