

#include <mforms/box.h>
#include <mforms/mforms.h>

using namespace mforms;

Box::Box(bool horiz)
{
  _box_impl= &ControlFactory::get_instance()->_box_impl;

  _box_impl->create(this, horiz);
}

void Box::add(View *subview, bool expand, bool fill)
{
  subview->set_parent(this);
  _box_impl->add(this, subview, expand, fill);
}


void Box::add_end(View *subview, bool expand, bool fill)
{
  subview->set_parent(this);
  _box_impl->add_end(this, subview, expand, fill);
}


void Box::remove(View *subview)
{
  _box_impl->remove(this, subview);
}


void Box::set_homogeneous(bool flag)
{
  _box_impl->set_homogeneous(this, flag);
}


void Box::set_spacing(int space)
{
  _box_impl->set_spacing(this, space);
}

void Box::set_padding(int padding)
{
  _box_impl->set_padding(this, padding);
}


void Box::set_back_color(const std::string &color)
{
  _box_impl->set_back_color(this, color);
}

