#ifndef _LF_BUTTON_H_
#define _LF_BUTTON_H_


#include "mforms/button.h"

#include "lf_view.h"


namespace mforms {
namespace gtk {

class ButtonImpl : public ViewImpl
{
 protected:
  Gtk::Button *_button;
  virtual Gtk::Widget *get_outer() const { return _button; }

  ButtonImpl(::mforms::Button *self)
    : ViewImpl(self)
  {
    _button= Gtk::manage(new Gtk::Button("", true));
    _button->signal_clicked().connect(sigc::mem_fun(*self, &::mforms::Button::callback));
    
    setup();
  }

  static bool create(::mforms::Button *self)
  {
    return new ButtonImpl(self) != 0;
  }

  static void set_text(::mforms::Button *self, const std::string &text)
  {
    if ( self )
    {
      ButtonImpl* button = self->get_data<ButtonImpl>();

      if ( button )
      {
        button->_button->set_label(text);
      }
    }
  }

public:
  static void init()
  {
    ::mforms::ControlFactory *f = ::mforms::ControlFactory::get_instance();

    f->_button_impl.create= &ButtonImpl::create;
    f->_button_impl.set_text= &ButtonImpl::set_text;
  }
};

}
}

#endif
