#ifndef _LF_CHECKBOX_H_
#define _LF_CHECKBOX_H_

#include <mforms/mforms.h>

#include "lf_button.h"

namespace mforms {
namespace gtk {

class CheckBoxImpl : public ButtonImpl
{
  Gtk::CheckButton *_check;
  virtual Gtk::Widget *get_outer() { return _check; }

 protected:
  static bool create(::mforms::CheckBox *self)
  {
    return new CheckBoxImpl(self) != 0;
  }

  static void set_active(::mforms::CheckBox *self, bool flag)
  {
    CheckBoxImpl* cb = self->get_data<CheckBoxImpl>();

    if ( cb )
      cb->_check->set_active(flag);
  }

  static bool get_active(::mforms::CheckBox *self)
  {
    CheckBoxImpl* cb = self->get_data<CheckBoxImpl>();
    return ( cb ? cb->_check->get_active() : false);
  }

  CheckBoxImpl(::mforms::CheckBox *self)
    : ButtonImpl(self)
  {
    delete _button;
    _check = Gtk::manage(new Gtk::CheckButton());
    _check->signal_clicked().connect(sigc::mem_fun(*self, &::mforms::Button::callback));
    _check->signal_toggled().connect(sigc::mem_fun(*self, &::mforms::CheckBox::toggled));
    _button= _check;
  }

 public:
  static void init()
  {
    ::mforms::ControlFactory *f= ::mforms::ControlFactory::get_instance();

    f->_checkbox_impl.create     = &CheckBoxImpl::create;
    f->_checkbox_impl.set_active = &CheckBoxImpl::set_active;
    f->_checkbox_impl.get_active = &CheckBoxImpl::get_active;
  }
};

};
};

#endif
