#ifndef _LF_IMAGEBOX_H_
#define _LF_IMAGEBOX_H_

#include "mforms/label.h"

#include "lf_view.h"

namespace mforms {
namespace gtk {

class ImageBoxImpl : public ViewImpl
{
protected:
  Gtk::Image *_image;
  virtual Gtk::Widget *get_outer() const { return _image; }

  ImageBoxImpl(::mforms::ImageBox *self)
    : ViewImpl(self)
  {
    _image = Gtk::manage(new Gtk::Image());
    _image->set_alignment(0, 0.5);

    setup();
  }

  static bool create(::mforms::ImageBox *self)
  {
    return new ImageBoxImpl(self) != 0;
  }

  static void set_image(::mforms::ImageBox *self, const std::string &file)
  {
    ImageBoxImpl* image = self->get_data<ImageBoxImpl>();

    if (image)
    {
      image->_image->set(file);
    }
  }

 public:
  static void init()
  {
    ::mforms::ControlFactory *f = ::mforms::ControlFactory::get_instance();

    f->_imagebox_impl.create         = &ImageBoxImpl::create;
    f->_imagebox_impl.set_image      = &ImageBoxImpl::set_image;
  }
};

};
};


#endif /* _LF_IMAGEBOX_H_ */
