#ifndef _LF_PROGRESSBAR_H_
#define _LF_PROGRESSBAR_H_


#include "mforms/progressbar.h"

#include "lf_view.h"

namespace mforms {
namespace gtk {

class ProgressBarImpl : public ViewImpl
{
 protected:
  Gtk::ProgressBar *_pbar;
  virtual Gtk::Widget *get_outer() const { return _pbar; }
  

  ProgressBarImpl(::mforms::ProgressBar *self)
    : ViewImpl(self)
  {
    _pbar= Gtk::manage(new Gtk::ProgressBar());

    setup();
  }

  static bool create(::mforms::ProgressBar *self)
  {
    return new ProgressBarImpl(self) != 0;
  }
  
  static void set_value(::mforms::ProgressBar *self, float pct)
  {
    ProgressBarImpl *progressbar= self->get_data<ProgressBarImpl>();
    
    if (progressbar)
      progressbar->_pbar->set_fraction(pct);
  }

 public:
  static void init()
  {
    ::mforms::ControlFactory *f = ::mforms::ControlFactory::get_instance();

    f->_progressbar_impl.create         = &ProgressBarImpl::create;
    f->_progressbar_impl.set_value      = &ProgressBarImpl::set_value;
  }
};

};
};


#endif /* _LF_PROGRESSBAR_H_ */
