#ifndef _LF_SCROLL_PANEL_H_
#define _LF_SCROLL_PANEL_H_


#include "mforms/scrollpanel.h"

#include "lfi_container.h"

namespace mforms
{
namespace gtk
{

class ScrollPanelImpl : public ContainerImpl
{
  Gtk::ScrolledWindow *_swin;

  virtual Gtk::Widget *get_outer() const { return _swin; }
  virtual Gtk::Widget *get_inner() const { return _swin; }
  
protected:
  ScrollPanelImpl(::mforms::ScrollPanel *self, bool bordered)
    : ContainerImpl(self)
  {
    _swin= Gtk::manage(new Gtk::ScrolledWindow());

    _swin->set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC);
    
    if (bordered)
      _swin->set_shadow_type(Gtk::SHADOW_IN);
    else
      _swin->set_shadow_type(Gtk::SHADOW_NONE);
  }

  static bool create(::mforms::ScrollPanel *self, bool bordered)
  {
    return new ScrollPanelImpl(self, bordered) != 0;
  }

  static void add(::mforms::ScrollPanel *self, ::mforms::View *child)
  {
    ScrollPanelImpl *panel= self->get_data<ScrollPanelImpl>();

    panel->_swin->add(*child->get_data<ViewImpl>()->get_outer());
    
    // remove border around viewport
    ((Gtk::Viewport*)panel->_swin->get_child())->set_shadow_type(Gtk::SHADOW_NONE);
  }

  static void remove(::mforms::ScrollPanel *self)
  {
    ScrollPanelImpl *panel= self->get_data<ScrollPanelImpl>();
    
    panel->_swin->remove();
  }

 public:
  static void init()
  {
    ::mforms::ControlFactory *f = ::mforms::ControlFactory::get_instance();

    f->_spanel_impl.create         = &ScrollPanelImpl::create;

    f->_spanel_impl.add            = &ScrollPanelImpl::add;
    f->_spanel_impl.remove         = &ScrollPanelImpl::remove;    
  }
};

};
};


#endif
