#include <mforms/listbox.h>

#include <mforms/mforms.h>

using namespace mforms;


ListBox::ListBox(bool multi_select)
{
  _listbox_impl= &ControlFactory::get_instance()->_listbox_impl;

  _listbox_impl->create(this, multi_select);
}


void ListBox::clear()
{
  _listbox_impl->clear(this);
}


int ListBox::add_item(const std::string &item)
{
  return _listbox_impl->add_item(this, item);
}


void ListBox::add_items(const std::list<std::string> &items)
{
  _listbox_impl->add_items(this, items);
}


void ListBox::set_selected(int index)
{
  _listbox_impl->set_index(this, index);
}


std::string ListBox::get_string_value()
{
  return _listbox_impl->get_text(this);
}


int ListBox::get_selected_index()
{
  return _listbox_impl->get_index(this);
}


void ListBox::callback()
{
  _signal_changed.emit();
}
