#ifndef _MFORMS_BASE_H_
#define _MFORMS_BASE_H_

#include <string>
#include <list>

#ifdef _WIN32
# ifdef DECL_MFORMS_EXPORT
#  define MFORMS_EXPORT __declspec(dllexport)
# else
#  define MFORMS_EXPORT __declspec(dllimport)
# endif
#else
# define MFORMS_EXPORT
#endif

#ifndef _WIN32
#define __stdcall 
#endif

namespace mforms {
  class ControlFactory;

  class MFORMS_EXPORT Object
  {
  public:
    void set_data(void *data) { _data= data; }

    template<class C>
      C* get_data() { return reinterpret_cast<C*>(_data); }

    void *get_data_ptr() { return _data; }

  private:
    void *_data;
  };
};

#endif
