#ifndef _MFORMS_BOX_H_
#define _MFORMS_BOX_H_

#include <mforms/view.h>
#include <map>

namespace mforms {
  
  class Box;
  
  struct BoxImplPtrs
  {
    bool (__stdcall *create)(Box *self, bool horizontal);
    void (__stdcall *add)(Box *self, View *child, bool expand, bool fill);
    void (__stdcall *add_end)(Box *self, View *child, bool expand, bool fill);
    void (__stdcall *remove)(Box *self, View *child);
    void (__stdcall *set_homogeneous)(Box *self, bool);
    void (__stdcall *set_spacing)(Box *self, int);
    void (__stdcall *set_padding)(Box *self, int);
    void (__stdcall *set_back_color)(Box *self, const std::string&);
  };

  class MFORMS_EXPORT Box : public View
  {
  public:
    Box(bool horiz);

    void add(View *subview, bool expand, bool fill= false);
    void add_end(View *subview, bool expand, bool fill= false);
    virtual void remove(View *subview);

    void set_homogeneous(bool flag);
    void set_spacing(int space);
    void set_padding(int padding);
    
    void set_back_color(const std::string&);
    
  protected:
    BoxImplPtrs *_box_impl;
  };
  
};

#endif /* _MFORMS_BOX_H_ */
