#ifndef _MFORMS_CHECKBOX_H_
#define _MFORMS_CHECKBOX_H_

#include <mforms/base.h>
#include <mforms/button.h>


namespace mforms {
  class CheckBox;

  struct CheckBoxImplPtrs
  {
    bool (__stdcall *create)(CheckBox *self);
    void (__stdcall *set_active)(CheckBox *self, bool flag);
    bool (__stdcall *get_active)(CheckBox *self);
  };

  class MFORMS_EXPORT CheckBox : public Button
  {
  public:
    CheckBox();

    void set_active(bool flag);
    bool get_active();
    
    virtual int get_int_value() { return get_active() ? 1 : 0; }
    virtual bool get_bool_value() { return get_active(); }
    virtual std::string get_string_value() { return get_active() ? "1" : "0"; }

    sigc::signal<void> signal_toggled() { return _signal_toggled; }
    
    
  public:
    void toggled() { _signal_toggled.emit(); }
    
  protected:
    CheckBoxImplPtrs *_checkbox_impl;
    
    sigc::signal<void> _signal_toggled;
  };
};

#endif
