#ifndef _MFILECHOOSERS_FILECHOOSER_H_
#define _MFILECHOOSERS_FILECHOOSER_H_

#include <mforms/base.h>
#include <mforms/view.h>


namespace mforms {
  enum FileChooserType
  {
    OpenFile=  1,
    SaveFile=  2,
    OpenDirectory= 3
  };

  class FileChooser;

  struct MFORMS_EXPORT FileChooserImplPtrs
  {
    bool (__stdcall *create)(FileChooser *self, FileChooserType type);
    void (__stdcall *set_title)(FileChooser *self, const std::string &title);
    bool (__stdcall *run_modal)(FileChooser *self);
    void (__stdcall *set_path)(FileChooser *self, const std::string &path);
    std::string (__stdcall *get_path)(FileChooser *self);
    void (__stdcall *set_extensions)(FileChooser *self, const std::string &extensions, const std::string &default_extension);
  };

  class MFORMS_EXPORT FileChooser : public View
  {
    FileChooserImplPtrs *_filechooser_impl;
  public:
    FileChooser(FileChooserType);

    virtual void set_title(const std::string &title);
    virtual bool run_modal();
    void set_path(const std::string &path);
    std::string get_path();
    void set_extensions(const std::string &extensions, const std::string &default_extension);
  };
};

#endif
