#ifndef _MFORMS_LABEL_H_
#define _MFORMS_LABEL_H_

#include <mforms/base.h>
#include <mforms/view.h>


namespace mforms {
  class Label;

  enum Alignment
  {
    BottomLeft,
    BottomCenter,
    BottomRight,
    MiddleLeft,
    MiddleCenter,
    MiddleRight,
    TopLeft,
    TopCenter,
    TopRight
  };

  enum LabelStyle
  {
    NormalStyle,
    BoldStyle,
    BigStyle,
    BigBoldStyle,
    SmallStyle
  };

  struct LabelImplPtrs
  {
    bool (__stdcall *create)(Label *self);
    void (__stdcall *set_style)(Label *self, LabelStyle style);
    void (__stdcall *set_text)(Label *self, const std::string &text);
    void (__stdcall *set_text_align)(Label *self, Alignment align);
    void (__stdcall *set_color)(Label *self, const std::string &color);
    void (__stdcall *set_wrap_text)(Label *self, bool flag);
  };

  class MFORMS_EXPORT Label : public View
  {
  public:
    Label();

    void set_wrap_text(bool flag);
    void set_text_align(Alignment align);
    void set_text(const std::string &text);
    void set_style(LabelStyle style);
    void set_color(const std::string &color);

  protected:
    LabelImplPtrs *_label_impl;
  };
};

#endif
