#ifndef _MFORMS_LISTBOX_H_
#define _MFORMS_LISTBOX_H_

#include <mforms/base.h>
#include <mforms/control.h>


namespace mforms {
  class ListBox;

  struct ListBoxImplPtrs
  {
    bool (__stdcall *create)(ListBox *self, bool multi_select);
    void (__stdcall *clear)(ListBox *self);
    void (__stdcall *add_items)(ListBox *self, const std::list<std::string> &items);
    int (__stdcall *add_item)(ListBox *self, const std::string &item);
    std::string (__stdcall *get_text)(ListBox *self);
    void (__stdcall *set_index)(ListBox *self, int index);
    int (__stdcall *get_index)(ListBox *self);
  };


  class MFORMS_EXPORT ListBox : public Control
  {
  public:
    ListBox(bool multi);

    void clear();
    int add_item(const std::string &item);
    void add_items(const std::list<std::string> &items);

    void set_selected(int index);

    virtual std::string get_string_value();
    int get_selected_index();

    sigc::signal<void> signal_changed() { return _signal_changed; }

  public:
    void callback();

  protected:
    ListBoxImplPtrs *_listbox_impl;
    
    sigc::signal<void> _signal_changed;
  };
};

#endif
