#ifndef _MFORMS_POPUPSELECT_H_
#define _MFORMS_POPUPSELECT_H_

#include <mforms/base.h>
#include <mforms/control.h>


namespace mforms {
  class Selector;

  struct SelectorImplPtrs
  {
    bool (__stdcall *create)(Selector *self);
    void (__stdcall *clear)(Selector *self);
    void (__stdcall *add_items)(Selector *self, const std::list<std::string> &items);
    int (__stdcall *add_item)(Selector *self, const std::string &item);
    std::string (__stdcall *get_text)(Selector *self);
    void (__stdcall *set_index)(Selector *self, int index);
    int (__stdcall *get_index)(Selector *self);
  };


  class MFORMS_EXPORT Selector : public Control
  {
  public:
    Selector();

    void clear();
    int add_item(const std::string &item);
    void add_items(const std::list<std::string> &items);

    void set_selected(int index);

    virtual std::string get_string_value();
    int get_selected_index();

    sigc::signal<void> signal_changed() { return _signal_changed; }

  public:
    void callback();

  protected:
    SelectorImplPtrs *_selector_impl;
    
    sigc::signal<void> _signal_changed;
  };
};

#endif
