#ifndef _MFORMS_TEXTENTRY_H_
#define _MFORMS_TEXTENTRY_H_

#include <mforms/base.h>
#include <mforms/control.h>

#include <sigc++/sigc++.h>

namespace mforms {
  class TextEntry;

  struct TextEntryImplPtrs
  {
    bool (__stdcall *create)(TextEntry *self);
    void (__stdcall *set_text)(TextEntry *self, const std::string &text);
    void (__stdcall *set_password)(TextEntry *self, bool flag);
    void (__stdcall *set_max_length)(TextEntry *self, int len);
    std::string (__stdcall *get_text)(TextEntry *self);
  };

  class MFORMS_EXPORT TextEntry : public Control
  {
  public:
    TextEntry();

    void set_max_length(int len);
    void set_password(bool flag);
    void set_value(const std::string &text);
    virtual std::string get_string_value();

    sigc::signal<void> signal_changed() { return _signal_changed; }

  public:
    void callback();

    void focus_out();

  protected:
    TextEntryImplPtrs *_textentry_impl;
    
    sigc::signal<void> _signal_changed;
  };
};

#endif
