
#include <mforms/mforms.h>


using namespace mforms;


Panel::Panel(bool bordered)
{
  _panel_impl= &ControlFactory::get_instance()->_panel_impl;

  _panel_impl->create(this, bordered);
}


void Panel::set_title(const std::string &title)
{
  _panel_impl->set_title(this, title);
}


void Panel::set_back_color(const std::string &color)
{
  _panel_impl->set_back_color(this, color);
}


void Panel::set_check_title(const std::string &title)
{
  _panel_impl->set_check_title(this, title);
}


void Panel::set_active(bool flag)
{
  _panel_impl->set_active(this, flag);
}


bool Panel::get_active()
{
  return _panel_impl->get_active(this);
}


void Panel::add(View *subview)
{
  subview->set_parent(this);
  (*_panel_impl->add)(this, subview);
  subview->show();
  _subviews.push_back(subview);
  
  needs_resize();
}


void Panel::remove(View *subview)
{
  subview->set_parent(0);
  _subviews.remove(subview);
  (*_panel_impl->remove)(this, subview);
  
  needs_resize();
}


void Panel::set_padding(int pad)
{
  (*_panel_impl->set_padding)(this, pad);
}
