#include <mforms/selector.h>

#include <mforms/mforms.h>

using namespace mforms;


Selector::Selector()
{
  _selector_impl= &ControlFactory::get_instance()->_selector_impl;

  _selector_impl->create(this);
}


void Selector::clear()
{
  _selector_impl->clear(this);
}


int Selector::add_item(const std::string &item)
{
  return _selector_impl->add_item(this, item);
}


void Selector::add_items(const std::list<std::string> &items)
{
  _selector_impl->add_items(this, items);
}


void Selector::set_selected(int index)
{
  _selector_impl->set_index(this, index);
}


std::string Selector::get_string_value()
{
  return _selector_impl->get_text(this);
}


int Selector::get_selected_index()
{
  return _selector_impl->get_index(this);
}


void Selector::callback()
{
  _signal_changed.emit();
}
