#include <mforms/textbox.h>
#include <mforms/mforms.h>

using namespace mforms;

TextBox::TextBox()
{
  _textbox_impl= &ControlFactory::get_instance()->_textbox_impl;

  _textbox_impl->create(this);
}


void TextBox::set_value(const std::string &text)
{
  _textbox_impl->set_text(this, text);
}


void TextBox::append_text(const std::string &text)
{
  _textbox_impl->append_text(this, text);
}


void TextBox::set_read_only(bool flag)
{
  _textbox_impl->set_read_only(this, flag);
}

void TextBox::set_padding(int pad)
{
  _textbox_impl->set_padding(this, pad);
}


std::string TextBox::get_string_value()
{
  return _textbox_impl->get_text(this);
}


void TextBox::callback()
{
  _signal_changed.emit();
}


