#include <mforms/textentry.h>
#include <mforms/mforms.h>

using namespace mforms;

TextEntry::TextEntry()
{
  _textentry_impl= &ControlFactory::get_instance()->_textentry_impl;

  _textentry_impl->create(this);
}


void TextEntry::set_value(const std::string &text)
{
  _textentry_impl->set_text(this, text);
}


void TextEntry::set_password(bool flag)
{
  _textentry_impl->set_password(this, flag);
}


void TextEntry::set_max_length(int len)
{
  _textentry_impl->set_max_length(this, len);
}


std::string TextEntry::get_string_value()
{
  return _textentry_impl->get_text(this);
}


void TextEntry::callback()
{
  _signal_changed.emit();
}
