#ifndef _GRT_DIFF_H
#define _GRT_DIFF_H

#include "grtpp.h"
#include "grtpp_util.h"

namespace grt
{
class ValueRef;
class BaseListRef;
class DictRef;
//class ObjectRef;
class DiffChange;


class GrtDiff
{
protected:
  const Omf* omf;
  virtual DiffChange *on_simple_value(DiffChange *parent, const ValueRef &source, const ValueRef &target, bool caseinsensitive= false);
  virtual DiffChange *on_list(DiffChange *parent, const BaseListRef &source, const BaseListRef &target);
  virtual DiffChange *on_dict(DiffChange *parent, const DictRef &source, const DictRef &target);
  virtual DiffChange *on_object(DiffChange *parent, const ObjectRef &source, const ObjectRef &target);

  virtual DiffChange *on_uncompatible(DiffChange *parent, const ValueRef &source, const ValueRef &target);

  DiffChange *on_value(DiffChange *parent, const ValueRef &source, const ValueRef &target, bool caseinsensitive= false);
public:
  GrtDiff() : omf(NULL) {};
  DiffChange *diff(const ValueRef &source, const ValueRef &target, const Omf* omf= NULL);
  virtual ~GrtDiff() {}
};

}

#endif
