#ifndef _GRTPP_SERIALIZER_H__
#define _GRTPP_SERIALIZER_H__

#include "grtpp.h"

#include <set>

namespace grt
{
  namespace internal
  {
    class Serializer
    {
    public:
      Serializer(GRT *grt);

      void save_to_xml(const ValueRef &value, const std::string &path, 
                       const std::string &doctype= "", const std::string &docversion= "");

      xmlDocPtr create_xmldoc_for_value(const ValueRef &value,
                                        const std::string &doctype, const std::string &docversion);

      std::string serialize_to_xmldata(const ValueRef &value,
                                       const std::string &type, const std::string &version);

    protected:
      GRT *_grt;
      std::set<void*> _cache;
      
      xmlNodePtr serialize_value(const ValueRef &value, xmlNodePtr parent, bool owned_objects);
      xmlNodePtr serialize_object(const Ref<Object> &object, xmlNodePtr parent);

      bool seen(const ValueRef &value);
       
      bool serialize_member(const MetaClass::Member *member, const ObjectRef &object, xmlNodePtr node);
    };
  };
};

#endif
