#ifndef _MYSQL_SQL_PARSER_FE_H_
#define _MYSQL_SQL_PARSER_FE_H_


#include "myx_sql_tree_item.h"
#include "mysql_sql_parser_public_interface.h"


/** Splits provided SQL script into statements and parses them in turn providing generated AST to given callback.
 * 
 * @ingroup sqlparser
 */
class MYSQL_SQL_PARSER_PUBLIC_FUNC Mysql_sql_parser_fe
{
public:
  Mysql_sql_parser_fe();

  typedef int (* fe_process_sql_statement_callback)(void* user_data, const MyxStatementParser *splitter, const char *sql, const MyxSQLTreeItem *tree, int lineno, const std::string &err_msg);
  int parse_sql_script(const char *sql_script, fe_process_sql_statement_callback cb, void *user_data);
  int parse_sql_script_file(const char *sql_script_filename, fe_process_sql_statement_callback cb, void *user_data);

  bool ignore_dml;
  bool processing_create_statements;
  bool processing_alter_statements;
  bool processing_drop_statements;

private:
  static int process_sql_statement_cb(const MyxStatementParser *splitter, const char *sql, void *context);
};


#endif // _MYSQL_SQL_PARSER_FE_H_
