#include "stdafx.h"

#include "grts/structs.workbench.physical.h"
#include "grts/structs.db.mgmt.h"
#include "wb_module_validation_mysql.h"
#include "interfaces/plugin.h"


static void set_object_argument(app_PluginRef &plugin, const std::string &struct_name)
{
  app_PluginObjectInputRef pdef(plugin.get_grt());

  pdef->objectStructName(struct_name);
  pdef->owner(plugin);

  plugin->inputValues().insert(pdef);
}



grt::ListRef<app_Plugin> WbModuleValidationMySQLImpl::getPluginInfo()
{
  grt::ListRef<app_Plugin> plugins(get_grt());


#define DECLARE_PLUGIN(method)  \
  {\
    app_PluginRef plugin(get_grt());\
    plugin->moduleName("WbModuleValidationMySQL");\
    plugin->pluginType("normal");\
    plugin->moduleFunctionName(#method);\
    set_object_argument(plugin, "workbench.physical.Model");\
    plugin->rating(100);\
    plugin->name("db.mysql.plugin.wb."#method);\
    plugin->groups().insert("catalog/Editors");\
    plugins.insert(plugin);\
    plugin->showProgress(1);\
  }

DECLARE_PLUGIN(validateAll);                     
DECLARE_PLUGIN(validateIntegrity);               
DECLARE_PLUGIN(validateTableNameLength);         
DECLARE_PLUGIN(validateViewNameLength);          
DECLARE_PLUGIN(validateRoutineNameLength);       
DECLARE_PLUGIN(validateUserNameLength);          
DECLARE_PLUGIN(validateForeignKeyWithEngineType);
DECLARE_PLUGIN(validateViewColumns);             
DECLARE_PLUGIN(validateRoutineColumns);          
DECLARE_PLUGIN(validateDefaultValueType);        
DECLARE_PLUGIN(validatePartionningScheme);       
DECLARE_PLUGIN(validateSyntax);                  
DECLARE_PLUGIN(validateTriggerSyntax);           
DECLARE_PLUGIN(validateViewSyntax);              
DECLARE_PLUGIN(validateRoutineSyntax);           
DECLARE_PLUGIN(validateReservedKeywords);        
DECLARE_PLUGIN(validateCharacters);              
DECLARE_PLUGIN(validateDuplicatesAdditions);

  return plugins;
}
