#include "stdafx.h"

#include "wb_module_validation.h"
#include "interfaces/plugin.h"

#include "grts/structs.db.mgmt.h"


static void set_object_argument(app_PluginRef &plugin, const std::string &struct_name)
{
  app_PluginObjectInputRef pdef(plugin.get_grt());

  pdef->objectStructName(struct_name);
  pdef->owner(plugin);

  plugin->inputValues().insert(pdef);
}



grt::ListRef<app_Plugin> WbModuleValidationImpl::getPluginInfo()
{
  grt::ListRef<app_Plugin> plugins(get_grt());


#define DECLARE_PLUGIN(method)  \
  {\
    app_PluginRef plugin(get_grt());\
    plugin->moduleName("WbModuleValidation");\
    plugin->pluginType("normal");\
    plugin->moduleFunctionName(#method);\
    set_object_argument(plugin, "workbench.physical.Model");\
    plugin->rating(100);\
    plugin->showProgress(2);\
    plugin->name("db.plugin.wb."#method);\
    plugin->groups().insert("catalog/Validations");\
    plugins.insert(plugin);\
  }

DECLARE_PLUGIN(validateAll);
DECLARE_PLUGIN(validateEmptyContent);
DECLARE_PLUGIN(validateTableHasColumns);
DECLARE_PLUGIN(validateViewHasCode);
DECLARE_PLUGIN(validateRoutineGroupHasMembers);
DECLARE_PLUGIN(validateRoutineHasCode);
DECLARE_PLUGIN(validateAllObjectsWithPrivileges);
DECLARE_PLUGIN(validateTableIsReferencedByRole);
DECLARE_PLUGIN(validateViewIsReferencedByRole);
DECLARE_PLUGIN(validateRoutineIsReferencedByRole);
DECLARE_PLUGIN(validateUserHasRoles);
DECLARE_PLUGIN(validateRoleHasPrivileges);
DECLARE_PLUGIN(validatePrivilegeHasObjects);
DECLARE_PLUGIN(validateTableIsUsedByView);
DECLARE_PLUGIN(validateViewIsUsedByView);
DECLARE_PLUGIN(validateRoutineIsUsedByView);
DECLARE_PLUGIN(validateRoutineGroupIsUsedByView);
DECLARE_PLUGIN(validateTableEfficiency);
DECLARE_PLUGIN(validateTableHasPrimaryKey);
DECLARE_PLUGIN(validatePrimaryKeyIsIntBased);
DECLARE_PLUGIN(validateColumnHasType);
DECLARE_PLUGIN(validateForeignKeyType);
DECLARE_PLUGIN(validateDuplicateIdentifiers);
DECLARE_PLUGIN(validateDuplicateTableName);
DECLARE_PLUGIN(validateDuplicateColumnName);
DECLARE_PLUGIN(validateDuplicateIndexName);
DECLARE_PLUGIN(validateDuplicateViewName);
DECLARE_PLUGIN(validateDuplicateRoutineName);
DECLARE_PLUGIN(validateDuplicateRoutineGroupName);
DECLARE_PLUGIN(validateDuplicateRoleName);
DECLARE_PLUGIN(validateDuplicateUserName);
DECLARE_PLUGIN(validateConsistency);
DECLARE_PLUGIN(validateDataTypeConsistencyByColumnName);
DECLARE_PLUGIN(validateLogic);
DECLARE_PLUGIN(validateForeignKeysRefersPrimaryKey);
DECLARE_PLUGIN(validateTableIsWriteable);
DECLARE_PLUGIN(validateNoStubTables);

  return plugins;
}
