#ifndef _MYSQL_EDITOR_RELATIONSHIP_H_
#define _MYSQL_EDITOR_RELATIONSHIP_H_

#include "grt/editor_base.h"

#include "grts/structs.workbench.physical.h"

#include "mysql_support_backend_public_interface.h"

#define RelationshipEditorBE_VERSION 1


class MYSQLWBMYSQLSUPPORTBACKEND_PUBLIC_FUNC RelationshipEditorBE : public bec::BaseEditor
{
protected:
  workbench_physical_ConnectionRef _relationship;

public: // editor interface
  RelationshipEditorBE(bec::GRTManager *grtm, const workbench_physical_ConnectionRef &relationship);

  GrtObjectRef get_object() { return get_relationship(); }

  workbench_physical_ConnectionRef get_relationship() { return _relationship; }

  void set_caption(const std::string &caption);
  std::string get_caption();

  void set_extra_caption(const std::string &caption);
  std::string get_extra_caption();

  void set_mandatory(bool flag);
  bool get_mandatory();

  void set_ref_mandatory(bool flag);
  bool get_ref_mandatory();

  void set_to_many(bool flag);
  bool get_to_many();

  void set_comment(const std::string &comment);
  std::string get_comment();

  bool get_visible();
  bool get_splitted();
  void set_visible(bool flag);
  void set_splitted(bool flag);
};

#endif /* _EDITOR_RELATIONSHIP_H_ */
