#ifndef __WB_MYSQL_TABLE_EDITOR_FK_PAGE_H__
#define __WB_MYSQL_TABLE_EDITOR_FK_PAGE_H__

#include <gtkmm.h>
#include "grt/tree_model.h"

class MySQLTableEditorBE;
class MGGladeXML;
class ListModelWrapper;
class DbMySQLTableEditor;

//==============================================================================
//
//==============================================================================
class DbMySQLTableEditorFKPage
{
  public:
    DbMySQLTableEditorFKPage(DbMySQLTableEditor *owner, MySQLTableEditorBE* be, MGGladeXML* xml);

    void refresh();
  
  private:
    void cell_editing_started(Gtk::CellEditable *cell, const Glib::ustring &path);
    void fkcol_cell_editing_started(Gtk::CellEditable *cell, const Glib::ustring &path);
    void cell_editing_done();
    void fk_cursor_changed();

    bool process_event(GdkEvent* event);
    void menu_action_on_node(Gtk::MenuItem* item);
    void delete_column(const Gtk::TreeModel::Path& path);

    void update_fk_details();

    void combo_box_changed(const int model_column); // column is either FKConstraintListBE::OnUpdate or FKConstraintListBE::OnDelete
    void set_comment(const std::string& comment);

    DbMySQLTableEditor                       *_owner;
    MySQLTableEditorBE                       *_be;
    MGGladeXML                               *_xml;

    Gtk::ComboBoxText                        *_fk_update_combo;
    Gtk::ComboBoxText                        *_fk_delete_combo;
    
    Gtk::TreeView                            *_fk_tv;
    Gtk::TreeView                            *_fk_columns_tv;
    Glib::RefPtr<ListModelWrapper>            _fk_model;
    Glib::RefPtr<ListModelWrapper>            _fk_columns_model;
    Glib::RefPtr<Gtk::ListStore>              _fk_tables_model;
    
    ::bec::NodeId                             _fk_node; //!< selected fk node
    sigc::connection                          _cell_edit_conn;
    sigc::connection                          _fkcol_cell_edit_conn;
};

#endif
