
class SynchronizeDifferencesPage : public WizardPage
{
  DbMySQLScriptSync *_be;
  sigc::slot<db_CatalogRef> get_source_catalog;

public:
  SynchronizeDifferencesPage(WizardForm *form, DbMySQLScriptSync *be)
    : WizardPage(form, "diffs"), _be(be)//, _bottom_box(true)
  {
    set_title(_("Model and Source Differences"));
    set_subtitle(_("Review differences and choose direction to apply changes."));

    add(&_tree, true, true);
/*    add(&_bottom_box, false, false);
    
    _bottom_box.set_spacing(8);

    _update_source.set_text(_("Update Source from Model"));
    _update_model.set_text(_("Update Model from Source"));
    _skip.set_text(_("Skip Change"));

    _bottom_box.add(&_update_source, false, true);
    _bottom_box.add(&_update_model, false, true);
    _bottom_box.add(&_skip, false, true);
*/

    _tree.add_column(mforms::IconStringGRTColumnType,
                     DiffTreeBE::ModelObjectName,
                     _("Model"));
    _tree.add_column(mforms::IconGRTColumnType,
                     DiffTreeBE::ApplyDirection,
                     _("Update"));
    _tree.add_column(mforms::IconStringGRTColumnType,
                     DiffTreeBE::DbObjectName,
                     _("Source"));

    _tree.signal_row_activate().connect(sigc::mem_fun(this, &SynchronizeDifferencesPage::activate_row));
  }


  void activate_row(const bec::NodeId &node, int column)
  {
    if (column == DiffTreeBE::ApplyDirection)
      _be->set_next_apply_direction(node);
  }
  
  void set_source_catalog_slot(const sigc::slot<db_CatalogRef> &source_catalog_slot)
  {
    get_source_catalog= source_catalog_slot;
  }


  virtual void load()
  {
    bec::TreeModel *diff_tree= _be->init_diff_tree(std::vector<std::string>(),
                                                   get_source_catalog ? get_source_catalog() : db_CatalogRef(),
                                                   db_CatalogRef());

    _tree.set_model(diff_tree);
  }

protected:
  GRTTreeView _tree;
  /*
  Box _bottom_box;
  Button _update_source;
  Button _update_model;
  Button _skip;
   */
};

