

#include "wb_editor_note.h"



NoteEditorBE::NoteEditorBE(bec::GRTManager *grtm, const workbench_model_NoteFigureRef &note)
: bec::BaseEditor(grtm, note), _note(note)
{
}




void NoteEditorBE::set_text(const std::string &text)
{
  bec::AutoUndoEdit undo(this, _note, "text");
  _note->text(text);
  undo.end(_("Change Note Text"));
}


std::string NoteEditorBE::get_text()
{
  return _note->text();
}


void NoteEditorBE::set_name(const std::string &name)
{
  bec::AutoUndoEdit undo(this, _note, "name");
  _note->name(name);
  undo.end(_("Change Note Name"));
}


std::string NoteEditorBE::get_name()
{
  return _note->name();
}
